diff -ur nagios-4.0.20130107/xdata/xodtemplate.c nagios-4.0.20130107.working/xdata/xodtemplate.c
--- nagios-4.0.20130107/xdata/xodtemplate.c	2012-12-24 19:56:13.000000000 +0000
+++ nagios-4.0.20130107.working/xdata/xodtemplate.c	2012-12-24 19:57:08.000000000 +0000
@@ -7186,6 +7186,7 @@
 int xodtemplate_register_contactgroup(xodtemplate_contactgroup *this_contactgroup) {
 	contactgroup *new_contactgroup = NULL;
 	objectlist *list;
+    char *temp_ptr;
 
 	/* bail out if we shouldn't register this object */
 	if(this_contactgroup->register_object == FALSE)
@@ -7200,6 +7201,17 @@
 		return ERROR;
 		}
 
+
+#ifdef NSCGI
+    /* Opsview patch: When reading CGIs, the contact groups are not expanded out correctly. We do this manually from 
+       the objects.cache, which is reliable as each item here should already be a valid contact.
+       It is okay to do the following member_list as this will be NULL
+    */
+    for(temp_ptr = strtok(this_contactgroup->members, ","); temp_ptr; temp_ptr = strtok(NULL, ",")) {
+		add_contact_to_contactgroup(new_contactgroup, temp_ptr);
+    }
+#endif
+
 	for(list = this_contactgroup->member_list; list; list = list->next) {
 		xodtemplate_contact *c = (xodtemplate_contact *)list->object_ptr;
 		add_contact_to_contactgroup(new_contactgroup, c->contact_name);
